git-am.shon commit Merge branch 'ra/anno' into next (0c82a39)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005, 2006 Junio C Hamano
   4
   5USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way] <mbox>
   6  or, when resuming [--skip | --resolved]'
   7. git-sh-setup
   8
   9git var GIT_COMMITTER_IDENT >/dev/null || exit
  10
  11stop_here () {
  12    echo "$1" >"$dotest/next"
  13    exit 1
  14}
  15
  16go_next () {
  17        rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
  18                "$dotest/patch" "$dotest/info"
  19        echo "$next" >"$dotest/next"
  20        this=$next
  21}
  22
  23fall_back_3way () {
  24    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`
  25
  26    rm -fr "$dotest"/patch-merge-*
  27    mkdir "$dotest/patch-merge-tmp-dir"
  28
  29    # First see if the patch records the index info that we can use.
  30    if git-apply -z --index-info "$dotest/patch" \
  31        >"$dotest/patch-merge-index-info" 2>/dev/null &&
  32        GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  33        git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
  34        GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
  35        git-write-tree >"$dotest/patch-merge-base+" &&
  36        # index has the base tree now.
  37        (
  38            cd "$dotest/patch-merge-tmp-dir" &&
  39            GIT_INDEX_FILE="../patch-merge-tmp-index" \
  40            GIT_OBJECT_DIRECTORY="$O_OBJECT" \
  41            git-apply $binary --index <../patch
  42        )
  43    then
  44        echo Using index info to reconstruct a base tree...
  45        mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
  46        mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
  47    else
  48        # Otherwise, try nearby trees that can be used to apply the
  49        # patch.
  50        (
  51            N=10
  52
  53            # Hoping the patch is against our recent commits...
  54            git-rev-list --max-count=$N HEAD
  55
  56            # or hoping the patch is against known tags...
  57            git-ls-remote --tags .
  58        ) |
  59        while read base junk
  60        do
  61            # See if we have it as a tree...
  62            git-cat-file tree "$base" >/dev/null 2>&1 || continue
  63
  64            rm -fr "$dotest"/patch-merge-* &&
  65            mkdir "$dotest/patch-merge-tmp-dir" || break
  66            (
  67                cd "$dotest/patch-merge-tmp-dir" &&
  68                GIT_INDEX_FILE=../patch-merge-tmp-index &&
  69                GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
  70                export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
  71                git-read-tree "$base" &&
  72                git-apply $binary --index &&
  73                mv ../patch-merge-tmp-index ../patch-merge-index &&
  74                echo "$base" >../patch-merge-base
  75            ) <"$dotest/patch"  2>/dev/null && break
  76        done
  77    fi
  78
  79    test -f "$dotest/patch-merge-index" &&
  80    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
  81    orig_tree=$(cat "$dotest/patch-merge-base") &&
  82    rm -fr "$dotest"/patch-merge-* || exit 1
  83
  84    echo Falling back to patching base and 3-way merge...
  85
  86    # This is not so wrong.  Depending on which base we picked,
  87    # orig_tree may be wildly different from ours, but his_tree
  88    # has the same set of wildly different changes in parts the
  89    # patch did not touch, so resolve ends up cancelling them,
  90    # saying that we reverted all those changes.
  91
  92    git-merge-resolve $orig_tree -- HEAD $his_tree || {
  93            if test -d "$GIT_DIR/rr-cache"
  94            then
  95                git-rerere
  96            fi
  97            echo Failed to merge in the changes.
  98            exit 1
  99    }
 100}
 101
 102prec=4
 103dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary=
 104
 105while case "$#" in 0) break;; esac
 106do
 107        case "$1" in
 108        -d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
 109        dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
 110        -d|--d|--do|--dot|--dote|--dotes|--dotest)
 111        case "$#" in 1) usage ;; esac; shift
 112        dotest="$1"; shift;;
 113
 114        -i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
 115        --interacti|--interactiv|--interactive)
 116        interactive=t; shift ;;
 117
 118        -b|--b|--bi|--bin|--bina|--binar|--binary)
 119        binary=t; shift ;;
 120
 121        -3|--3|--3w|--3wa|--3way)
 122        threeway=t; shift ;;
 123        -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
 124        sign=t; shift ;;
 125        -u|--u|--ut|--utf|--utf8)
 126        utf8=t; shift ;;
 127        -k|--k|--ke|--kee|--keep)
 128        keep=t; shift ;;
 129
 130        -r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
 131        resolved=t; shift ;;
 132
 133        --sk|--ski|--skip)
 134        skip=t; shift ;;
 135
 136        --)
 137        shift; break ;;
 138        -*)
 139        usage ;;
 140        *)
 141        break ;;
 142        esac
 143done
 144
 145# If the dotest directory exists, but we have finished applying all the
 146# patches in them, clear it out.
 147if test -d "$dotest" &&
 148   last=$(cat "$dotest/last") &&
 149   next=$(cat "$dotest/next") &&
 150   test $# != 0 &&
 151   test "$next" -gt "$last"
 152then
 153   rm -fr "$dotest"
 154fi
 155
 156if test -d "$dotest"
 157then
 158        test ",$#," = ",0," ||
 159        die "previous dotest directory $dotest still exists but mbox given."
 160        resume=yes
 161else
 162        # Make sure we are not given --skip nor --resolved
 163        test ",$skip,$resolved," = ,,, ||
 164                die "we are not resuming."
 165
 166        # Start afresh.
 167        mkdir -p "$dotest" || exit
 168
 169        git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
 170                rm -fr "$dotest"
 171                exit 1
 172        }
 173
 174        # -b, -s, -u and -k flags are kept for the resuming session after
 175        # a patch failure.
 176        # -3 and -i can and must be given when resuming.
 177        echo "$binary" >"$dotest/binary"
 178        echo "$sign" >"$dotest/sign"
 179        echo "$utf8" >"$dotest/utf8"
 180        echo "$keep" >"$dotest/keep"
 181        echo 1 >"$dotest/next"
 182fi
 183
 184case "$resolved" in
 185'')
 186        files=$(git-diff-index --cached --name-only HEAD) || exit
 187        if [ "$files" ]; then
 188           echo "Dirty index: cannot apply patches (dirty: $files)" >&2
 189           exit 1
 190        fi
 191esac
 192
 193if test "$(cat "$dotest/binary")" = t
 194then
 195        binary=--allow-binary-replacement
 196fi
 197if test "$(cat "$dotest/utf8")" = t
 198then
 199        utf8=-u
 200fi
 201if test "$(cat "$dotest/keep")" = t
 202then
 203        keep=-k
 204fi
 205if test "$(cat "$dotest/sign")" = t
 206then
 207        SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
 208                        s/>.*/>/
 209                        s/^/Signed-off-by: /'
 210                `
 211else
 212        SIGNOFF=
 213fi
 214
 215last=`cat "$dotest/last"`
 216this=`cat "$dotest/next"`
 217if test "$skip" = t
 218then
 219        this=`expr "$this" + 1`
 220        resume=
 221fi
 222
 223if test "$this" -gt "$last"
 224then
 225        echo Nothing to do.
 226        rm -fr "$dotest"
 227        exit
 228fi
 229
 230while test "$this" -le "$last"
 231do
 232        msgnum=`printf "%0${prec}d" $this`
 233        next=`expr "$this" + 1`
 234        test -f "$dotest/$msgnum" || {
 235                resume=
 236                go_next
 237                continue
 238        }
 239
 240        # If we are not resuming, parse and extract the patch information
 241        # into separate files:
 242        #  - info records the authorship and title
 243        #  - msg is the rest of commit log message
 244        #  - patch is the patch body.
 245        #
 246        # When we are resuming, these files are either already prepared
 247        # by the user, or the user can tell us to do so by --resolved flag.
 248        case "$resume" in
 249        '')
 250                git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
 251                        <"$dotest/$msgnum" >"$dotest/info" ||
 252                        stop_here $this
 253                git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
 254                ;;
 255        esac
 256
 257        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
 258        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
 259        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
 260
 261        if test -z "$GIT_AUTHOR_EMAIL"
 262        then
 263                echo "Patch does not have a valid e-mail address."
 264                stop_here $this
 265        fi
 266
 267        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 268
 269        SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
 270        case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
 271
 272        case "$resume" in
 273        '')
 274            if test '' != "$SIGNOFF"
 275            then
 276                LAST_SIGNED_OFF_BY=`
 277                    sed -ne '/^Signed-off-by: /p' \
 278                    "$dotest/msg-clean" |
 279                    tail -n 1
 280                `
 281                ADD_SIGNOFF=`
 282                    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
 283                    test '' = "$LAST_SIGNED_OFF_BY" && echo
 284                    echo "$SIGNOFF"
 285                }`
 286            else
 287                ADD_SIGNOFF=
 288            fi
 289            {
 290                echo "$SUBJECT"
 291                if test -s "$dotest/msg-clean"
 292                then
 293                        echo
 294                        cat "$dotest/msg-clean"
 295                fi
 296                if test '' != "$ADD_SIGNOFF"
 297                then
 298                        echo "$ADD_SIGNOFF"
 299                fi
 300            } >"$dotest/final-commit"
 301            ;;
 302        *)
 303                case "$resolved,$interactive" in
 304                tt)
 305                        # This is used only for interactive view option.
 306                        git-diff-index -p --cached HEAD >"$dotest/patch"
 307                        ;;
 308                esac
 309        esac
 310
 311        resume=
 312        if test "$interactive" = t
 313        then
 314            test -t 0 ||
 315            die "cannot be interactive without stdin connected to a terminal."
 316            action=again
 317            while test "$action" = again
 318            do
 319                echo "Commit Body is:"
 320                echo "--------------------------"
 321                cat "$dotest/final-commit"
 322                echo "--------------------------"
 323                printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
 324                read reply
 325                case "$reply" in
 326                [yY]*) action=yes ;;
 327                [aA]*) action=yes interactive= ;;
 328                [nN]*) action=skip ;;
 329                [eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
 330                       action=again ;;
 331                [vV]*) action=again
 332                       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
 333                *)     action=again ;;
 334                esac
 335            done
 336        else
 337            action=yes
 338        fi
 339
 340        if test $action = skip
 341        then
 342                go_next
 343                continue
 344        fi
 345
 346        if test -x "$GIT_DIR"/hooks/applypatch-msg
 347        then
 348                "$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
 349                stop_here $this
 350        fi
 351
 352        echo
 353        echo "Applying '$SUBJECT'"
 354        echo
 355
 356        case "$resolved" in
 357        '')
 358                git-apply $binary --index "$dotest/patch"
 359                apply_status=$?
 360                ;;
 361        t)
 362                # Resolved means the user did all the hard work, and
 363                # we do not have to do any patch application.  Just
 364                # trust what the user has in the index file and the
 365                # working tree.
 366                resolved=
 367                apply_status=0
 368                ;;
 369        esac
 370
 371        if test $apply_status = 1 && test "$threeway" = t
 372        then
 373                if (fall_back_3way)
 374                then
 375                    # Applying the patch to an earlier tree and merging the
 376                    # result may have produced the same tree as ours.
 377                    changed="$(git-diff-index --cached --name-only -z HEAD)"
 378                    if test '' = "$changed"
 379                    then
 380                            echo No changes -- Patch already applied.
 381                            go_next
 382                            continue
 383                    fi
 384                    # clear apply_status -- we have successfully merged.
 385                    apply_status=0
 386                fi
 387        fi
 388        if test $apply_status != 0
 389        then
 390                echo Patch failed at $msgnum.
 391                stop_here $this
 392        fi
 393
 394        if test -x "$GIT_DIR"/hooks/pre-applypatch
 395        then
 396                "$GIT_DIR"/hooks/pre-applypatch || stop_here $this
 397        fi
 398
 399        tree=$(git-write-tree) &&
 400        echo Wrote tree $tree &&
 401        parent=$(git-rev-parse --verify HEAD) &&
 402        commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
 403        echo Committed: $commit &&
 404        git-update-ref HEAD $commit $parent ||
 405        stop_here $this
 406
 407        if test -x "$GIT_DIR"/hooks/post-applypatch
 408        then
 409                "$GIT_DIR"/hooks/post-applypatch
 410        fi
 411
 412        go_next
 413done
 414
 415rm -fr "$dotest"